unit uMain;

{$mode objfpc}{$H+}

interface

uses
  Windows, Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, uClass;

type

  { TForm1 }

  TForm1 = class(TForm)
    Image1: TImage;
    Memo1: TMemo;
    Timer1: TTimer;
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1;
  THEGAME: TGame;
  Cache: TBitmap;
  DoProcess: boolean;
  Tmp: Integer;

procedure Log(S: string);

implementation

procedure Log(S: string);
begin
 // Form1.Memo1.Lines.Add(S);
end;

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormShow(Sender: TObject);
begin
  randomize;
  Tmp := 1;
  THEGAME := TGame.Create;
  Cache := TBitmap.Create;
  Cache.Width := MAXX;
  Cache.Height := MAXY;
  DoProcess := false;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  case Key of
    vk_space: DoProcess := not DoProcess;
    Ord('S'): THEGAME.ProcessTime;
    Ord('G'): THEGAME.GenLevel;
    Ord('D'): THEGAME.Player.DrawMode := not THEGAME.Player.DrawMode;
    Ord('L'): THEGAME.LoadLevel('test.game');
  end;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
  begin
    THEGAME.Player.SetDirTo(X, Y);
    DoProcess := False;
  end
  else if Button = mbRight then
    with TSource.Create(THEGAME,X,Y, 1, Fire{TElement(Random(Ord(High(TElement))+1))})do
    begin
      Name := '['+IntToStr(Tmp)+']';
      Inc(Tmp);
    end
  else if Button = mbMiddle then
    with TSource.Create(THEGAME,X,Y, 1, RandomElement)do
    begin
      Name := '['+IntToStr(Tmp)+']';
      Inc(Tmp);
    end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := false;
  if DoProcess then
    THEGAME.ProcessTime;
  with THEGAME.Player do
    if abs(TargetX - X)+abs(TargetY - Y)<1e-3 then
      DoProcess := false;
  THEGAME.Draw(Cache.Canvas);
  Image1.Canvas.Draw(0,0,Cache);
  Timer1.Enabled := True;
end;

end.

